/*
 * File         : test5.java
 * Author       : Guansong Zhang
 * Created      : Mon Jan 12 12:48:19 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1998/04/21 21:41:41 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class test5 {

  static final int n=8;

  public static void main(String argv[]) {
    SpmdEnv spmd = new SpmdEnv (argv);

    Procs2 p=new Procs2(2,2);

    if (p.on()) {

      BlockRange x = new BlockRange (n, p.dim(0));
      BlockRange y = new BlockRange (n, p.dim(1));
      
      Array2Float u = new Array2Float(x, y, spmd.apg);

      Index i = new Index (x);
      Index j = new Index (y);
      
      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  if (i.idx()==0 || i.idx()==n-1 || j.idx()==0 || j.idx()==n-1)
	    u.data[u.element(i, j)]=1;
	  else
	    u.data[u.element(i, j)]=0;
	} j.dim().revo();
      } i.dim().revo();
      
      Range xc=x.subrng(n-2, 1);      
      Range yc=y.subrng(n-2, 1);      


      Array2Float uLC=u.section(x.subrng(n-2,0),yc);
      Array2Float uRC=u.section(x.subrng(n-2,2),yc);
      Array2Float uCL=u.section(xc,y.subrng(n-2,0));
      Array2Float uCR=u.section(xc,y.subrng(n-2,2));

      Array2Float tmp1= new Array2Float(xc, yc, spmd.apg);
      Array2Float tmp2= new Array2Float(xc, yc, spmd.apg);
      Array2Float tmp3= new Array2Float(xc, yc, spmd.apg);
      Array2Float tmp4= new Array2Float(xc, yc, spmd.apg);

      for (int iter=1; iter<=5; iter++) {
	Adlib.remap(tmp1, uLC);
	Adlib.remap(tmp2, uRC);
	Adlib.remap(tmp3, uCL);
	Adlib.remap(tmp4, uCR);

	Index ic = new Index (xc);
	Index jc = new Index (yc);

	i.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  j.dim().over();
	  for (jc.begin(); jc.test(); jc.next()) {
	    u.data[u.element(ic,jc)]
	      =(float)0.25*(tmp1.data[tmp1.element(ic,jc)]+
			    tmp2.data[tmp2.element(ic,jc)]+
			    tmp3.data[tmp3.element(ic,jc)]+
			    tmp4.data[tmp4.element(ic,jc)]);
	  } jc.dim().revo();
	} ic.dim().revo();

	//Adlib.gprintf("iteration = %d\n", iter);
	Adlib.rprintln("iteration = "+iter);
	Adlib.aprintf("%7.3f%"+n+"N", u);

      }

    } p.no();

    spmd.finalize();

  }
}
